/***************************************************************************
                          ctraffic.h  -  description
                             -------------------
    begin                : Fri Apr 1 2005
    copyright            : (C) 2001-2003 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTRAFFIC_H
#define CTRAFFIC_H

/**
  *@author N.Cat
  */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <dclib/dcos.h>
#include <dclib/core/cobject.h>
#include <dclib/core/cstring.h>
#include <dclib/core/clist.h>

typedef enum eTrafficType {
	ettRX=0,
	ettTX,
	ettDATARX,
	ettDATATX,
	ettCONTROLRX,
	ettCONTROLTX,
	ettRESET
} eTrafficType;

class DLL_EXPORT CTraffic : public CObject {
public:
	/** */
	CTraffic();

	/** */
	virtual ~CTraffic();

	/** */
	void AddTraffic( eTrafficType type, ulonglong n );

	/** */
	ulonglong GetTraffic( eTrafficType type );

	/** */
	void ResetTraffic();
	
private:
	/** */
	CThread m_Thread;
	/** */
	ulonglong m_nRx;
	/** */
	ulonglong m_nTx;
	/** */
	ulonglong m_nDataRx;
	/** */
	ulonglong m_nDataTx;
	/** */
	ulonglong m_nControlRx;
	/** */
	ulonglong m_nControlTx;
};

#endif
