/***************************************************************************
                          cxferhandler.h  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002-2005 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXFERHANDLER_H
#define CXFERHANDLER_H

/**
  *@author Mathias Kster
  */

#include <dclib/dcos.h>
#include <dclib/dcobject.h>
#include <dclib/core/cthread.h>
#include <dclib/core/cobject.h>
#include <dclib/core/cstring.h>
#include <dclib/core/cstringlist.h>

#include <dclib/ctransfer.h>

class DLL_EXPORT CXFERObject : public CObject {
public:
	/** */
	CXFERObject() {
		m_pTransfer = 0;
		m_tTime = time(0);
	}
	/** */
	virtual ~CXFERObject() {
		if ( m_pTransfer )
			delete m_pTransfer;
	}

	/** */
	CTransfer * m_pTransfer;
	/** */
	time_t m_tTime;
};

class DLL_EXPORT CXFERHandler : public CObject {
public:
	/** */
	CXFERHandler();
	/** */
	virtual ~CXFERHandler();

	/** */
	bool AddXFER( int handle );
	/** */
	bool AddXFER( CString host, unsigned port, CString hubname, CString hubhost );
	/** */
	void Disconnect( ulonglong id );
	/** */
	bool Update();

	/** */
	void XFERVerifyTransfer( CTransfer * xfer );
	/** */
	void XFERVerifyDirection( CTransfer * xfer );
	/** */
	bool XFERInitDownload( CTransfer * xfer );
	/** */
	bool XFERInitUploadFile( CTransfer * xfer, CString name, ulonglong index, ulonglong size, bool adcmode = FALSE );

	/** */
	bool XFERUpdateDownload( CTransfer * xfer );

private:
	/** */
	ulonglong m_nID;
	/** */
	ulonglong GetNewID();
	
	/** */
	int XFERCallback( CObject * Sender, CObject * Object );
	/** */
	CThreadStringList * m_pXFERList;
};

#endif
