/***************************************************************************
                          cxfermanager.h  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002-2005 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXFERMANAGER_H
#define CXFERMANAGER_H

/**
  *@author Mathias Kster
  */

#include <dclib/dcos.h>
#include <dclib/core/cthread.h>
#include <dclib/core/csingleton.h>
#include <dclib/xfer/cxferusrslot.h>
#include <dclib/xfer/cxferusrban.h>
#include <dclib/xfer/cxferrequest.h>
#include <dclib/xfer/cxferhandler.h>
#include <dclib/xfer/cxfersharelist.h>

#define MAX_FILE_PRIORITY 5

#ifdef WIN32
//template class DLL_EXPORT CSingleton<CDownloadManager>;
#endif

class CXFERQueue;

class  DLL_EXPORT CXFERManager : /*public CSingleton<CXFERManager>,*/ public CObject {
public: 
	/** */
	CXFERManager();
	/** */
	virtual ~CXFERManager();

	/** load the queue */
	int XFERLoad();
	/** save the queue */
	int XFERSave();

	/** shutdown xfer manager */
	void XFERShutdown();
	/** return the current shutdownstate */
	eShutdownState DLM_ShutdownState() const { return m_eShutdownState; }
	
	/** */
	void XFERAdd( CString nick, CString hubname, CString hubhost,
				CString remotename, CString localname,
				CString localpath, CString localrootpath,
				eltMedium medium, ulonglong size,
				ulonglong startposition,
				ulonglong endposition,
				CString hash,
				bool multi = FALSE );

	/** */
	bool XFERAddRequest( CDCMessage * msg, CString hubname, CString hubhost );
	
	/** */
	int ListenCallback( CObject * /*Sender*/, CObject * Object );
	/** callback function */
	int Callback( CObject * Object1, CObject * Object2 );

protected:
	/** */
	friend class CXFERHandler;
	
	/** */
	CXFERQueue * m_pXFERQueue;
	/** */
	CXFERUsrSlot m_XFERUsrSlot;
	/** */
	CXFERUsrBan m_XFERUsrBan;
	/** */
	CXFERRequest m_XFERRequest;
	/** */
	CXFERHandler m_XFERHandler;
	/** */
	CXFERShareList m_XFERShareList;

//private:
	/** */
	ulonglong m_nID;
	/** */
	eShutdownState m_eShutdownState;
	/** */
	_CCallback * m_pCallback;
};

#endif
