/***************************************************************************
                       cxferrequest.h  -  description
                             -------------------
    begin                : Sat Feb 19 2005
    copyright            : (C) 2005 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CXFERREQUEST_H
#define CXFERREQUEST_H

/**
  *@author Mathias Kster
  */

#include <dclib/dcos.h>
#include <dclib/core/cobject.h>
#include <dclib/core/cstring.h>
#include <dclib/core/clist.h>

class DLL_EXPORT DCTransferRequest : public CObject {
public:
	/** */
	DCTransferRequest() {
		m_tTime  = 0;
		m_nCount = 0;
	};

	/** */
	virtual ~DCTransferRequest() {};

	/** */
	CString m_sNick;
	/** */
	CString m_sHubName;
	/** */
	CString m_sHubHost;
	/** */
	CString m_sUserHost;
	/** */
	ulonglong m_nCount;
	/** */
	time_t m_tTime;
};

class DLL_EXPORT CXFERRequest : public CObject {
public: 
	/** */
	CXFERRequest();
	/** */
	virtual ~CXFERRequest();

	/** */
	bool GetReq( CString nick, CString userhost, unsigned int userport, bool remove, CString & hubname, CString & hubhost );
	/** */
	bool AddReq( CString nick, CString hubname, CString hubhost, CString userhost = "", unsigned int userport = 0 );
	/** */
	void Update( time_t ttimeout );

private:
	/** */
	CThreadList<DCTransferRequest> *m_pRequestList;
};

#endif
